﻿var $this = this,
    game = {
        adClose: null,
        ads: true,
        adHeight: 0,
        adService: {
            android: {
                banner: 'ca-app-pub-4416763843913000/8605425170',
                interstitial: 'ca-app-pub-4416763843913000/6269237574'
            }
        },
        attempts: 1,
        audio: null,
        audiolist: null,
        banner: {
            loaded: false
        },
        bombs: 0,
        bombcap: 3,
        buttons: [],
        canPurchase: true,
        coin: 0,
        comboa: false,
        combob: false,
        connection: true,
        connection_banner: true,
        counter: 0,
        counter2: 0,
        ctx0: null,
        ctx1: null,
        ctx3: null,
        ctxTemp: null,
        delay: 0,
        flares: 0,
        flarecap: 5,
        friction: 3,
        fuel: false,
        gravity: 5,
        height: 960,
        height_half: 480,
        height_quarter: 240,
        height_threequarter: 720,
        id: null,
        images: {},
        inappsService: null,
        interstitial: {
            loaded: false
        },
        intro: false,
        keysDown: {},
        lander: false,
        landingangle: 0.05,
        landingv: 10,
        landed: 0,
        layer0: null,
        layer1: null,
        layer3: null,
        layerTemp: null,
        level: 1,
        limit: 50,
        longestFrame: 35,
        maxAttempts: 5,
        menu: false,
        message: false,
        message_health: undefined,
        objects: {
            powerup: null,
            tornado: null,
            coin: null
        },
        onboard: false,
        onboarding: false,
        opacity: null,
        padding: 0,
        pandir: -1,
        panydir: -1,
        paused: false,
        play: false,
        productIds: {
            noad: 'mars_lander_noad', coin1: 'mars_lander_coin1', coin2: 'mars_lander_coin2',
            shields: 'mars_lander_shields', fuel: 'mars_lander_fuel', lander: 'mars_lander_lander',
            comboa: 'mars_lander_combo1', combob: 'mars_lander_combo2',
            bombcap: 'mars_lander_bombcap', flarecap: 'mars_lander_flarecap'
        },
        productPrice_noad: '$0.99',
        productPrice_coin1: '$0.99',
        productPrice_coin2: '$1.99',
        productPrice_shields: '$0.99',
        productPrice_fuel: '$1.99',
        productPrice_lander: '$2.99',
        productPrice_comboa: '$1.99',
        productPrice_combob: '$1.99',
        productPrice_bombcap: '$0.99',
        productPrice_flarecap: '$1.99',
        rate: 0,
        rates: {
            hit: {
                meteor: 10,
                tornado: 10,
                bomb: 50
            },
            fuel: {
                single: 0.1,
                double: 0.15
            }
        },
        reload: false,
        review: false,
        scale: 0,
        score: [0],
        screen: 'splash',
        share: {},
        shop: false,
        shopping: false,
        shields: false,
        sound: true,
        sounds: {},
        splashImage: null,
        smallestFrame: 14,
        then: Date.now(),
        typicalFrame: 16,
        type: 1,
        width: 640,
        world: 1,
        init: function () {

            document.body.style.backgroundColor = '#000';
            document.body.style.margin = '0px';
            document.body.style.padding = '0px';
            document.body.style.overflow = 'hidden';

            var widthToHeight = game.width / game.height,
            newWidth = window.innerWidth,
            newHeight = window.innerHeight,
            newWidthToHeight = newWidth / newHeight,
            top, left;

            if (newWidthToHeight > widthToHeight) {
                newWidth = newHeight * widthToHeight;
                game.scale = (game.height / window.innerHeight);
            } else {
                newHeight = window.innerHeight;
                game.scale = (game.width / window.innerWidth);

                game.height = newHeight * game.scale;
                game.padding = Math.ceil((game.height - 960) / 2);
                game.height_half = game.height / 2;
                game.height_quarter = game.height / 4;
                game.height_threequarter = game.height_half + game.height_quarter;
            }
            left = window.innerWidth / 2 - newWidth / 2;
            top = window.innerHeight / 2 - newHeight / 2;

            //background
            game.layer0 = document.createElement('canvas');
            //game.ctx0 = game.layer0.getContext('2d', { antialias: false });
            game.ctx0 = game.layer0.getContext('2d');
            game.layer0.width = game.width;
            game.layer0.height = game.height;
            game.layer0.style.position = 'absolute';
            game.layer0.style.zIndex = '0';
            game.layer0.style.backgroundColor = 'transparent';
            game.layer0.style.top = top + 'px';
            game.layer0.style.left = left + 'px';
            game.layer0.style.height = Math.round(newHeight) + 'px';
            game.layer0.style.width = Math.round(newWidth) + 'px';

            document.body.appendChild(game.layer0);

            //player - animation
            game.layer1 = document.createElement('canvas');
            //game.ctx1 = game.layer1.getContext('2d', { antialias: false });
            game.ctx1 = game.layer1.getContext('2d');
            game.layer1.width = game.width;
            game.layer1.height = game.height;
            game.layer1.style.position = 'absolute';
            game.layer1.style.zIndex = '20';
            game.layer1.style.backgroundColor = 'transparent';
            game.layer1.style.top = top + 'px';
            game.layer1.style.left = left + 'px';
            game.layer1.style.height = Math.round(newHeight) + 'px';
            game.layer1.style.width = Math.round(newWidth) + 'px';

            document.body.appendChild(game.layer1);

            //buttons/text
            game.layer3 = document.createElement('canvas');
            //game.ctx3 = game.layer3.getContext('2d', { antialias: false });
            game.ctx3 = game.layer3.getContext('2d');
            game.layer3.width = game.width;
            game.layer3.height = game.height;
            game.layer3.style.position = 'absolute';
            game.layer3.style.zIndex = '30';
            game.layer3.style.backgroundColor = 'transparent';
            game.layer3.style.top = top + 'px';
            game.layer3.style.left = left + 'px';
            game.layer3.style.height = Math.round(newHeight) + 'px';
            game.layer3.style.width = Math.round(newWidth) + 'px';

            document.body.appendChild(game.layer3);

        },
		reinit: function(){
			var widthToHeight = game.width / game.height,
            newWidth = window.innerWidth,
            newHeight = window.innerHeight,
            newWidthToHeight = newWidth / newHeight,
            top, left;

            if (newWidthToHeight > widthToHeight) {
                newWidth = newHeight * widthToHeight;
                game.scale = (game.height / window.innerHeight);
            } else {
                newHeight = window.innerHeight;
                game.scale = (game.width / window.innerWidth);

                game.height = newHeight * game.scale;
                game.padding = Math.ceil((game.height - 960) / 2);
                game.height_half = game.height / 2;
                game.height_quarter = game.height / 4;
                game.height_threequarter = game.height_half + game.height_quarter;
            }
            left = window.innerWidth / 2 - newWidth / 2;
            top = window.innerHeight / 2 - newHeight / 2;
			
            game.layer0.width = game.width;
            game.layer0.height = game.height;
			game.layer0.style.top = top + 'px';
            game.layer0.style.left = left + 'px';
            game.layer0.style.height = Math.round(newHeight) + 'px';
            game.layer0.style.width = Math.round(newWidth) + 'px';
			
            game.layer1.width = game.width;
            game.layer1.height = game.height;
			game.layer1.style.top = top + 'px';
            game.layer1.style.left = left + 'px';
            game.layer1.style.height = Math.round(newHeight) + 'px';
            game.layer1.style.width = Math.round(newWidth) + 'px';

            game.layer3.width = game.width;
            game.layer3.height = game.height;
			game.layer3.style.top = top + 'px';
            game.layer3.style.left = left + 'px';
            game.layer3.style.height = Math.round(newHeight) + 'px';
            game.layer3.style.width = Math.round(newWidth) + 'px';
			
			game.layerTemp = CreateOffScreenCanvas(game.width, game.height);
            game.ctxTemp = game.layerTemp.getContext('2d');
					
		},
        initEvents: function () {
            /////////////////temp
            //document.addEventListener('keydown', function (event) {
            //    if (event.keyCode == 80) {
            //        if (game.play) PauseGame();
            //        return;
            //    } else if (event.keyCode == 32) {
            //        if (level.bomb) DeployBomb();
            //        return;
            //    }
            //    game.keysDown[event.keyCode] = true;
            //}, false);

            //document.addEventListener('keyup', function (event) {
            //    delete game.keysDown[event.keyCode];
            //}, false);
            /////////////////temp

            var touch_x = 0,
				touch_y = 0,
				touch_slide = false,
				touch_timer = null;
            document.addEventListener('touchstart', function (event) {
                for (var z = 0; z <= event.touches.length - 1; z++) {
                    var touch = event.touches[z],
                        x = parseInt(touch.clientX) - game.layer1.offsetLeft,
                        y = parseInt(touch.clientY) - game.layer1.offsetTop;

                    x = x * game.scale;
                    y = y * game.scale;

                    for (var i = 0; i <= game.buttons.length - 1; i++) {
                        var button = game.buttons[i];
                        if (y > button.y &&
            		        y < button.y + button.height &&
            		        x > button.x &&
            		        x < button.x + button.width) {
                            button.mousedown();
                            break;
                        }
                    }
                }
                if (game.menu || game.shopping || game.onboarding) {
                    if (game.shopping && (event.touches[0].clientY * game.scale < shop_y || event.touches[0].clientY * game.scale > shop_y + 400)) return;
                    touch_x = event.touches[0].clientX;
                    touch_y = event.touches[0].clientY;
                    clearTimeout(touch_timer);
                    touch_timer = setTimeout(function () { clearTimeout(touch_timer); touch_y = 0; touch_x = 0; }, 500);
                }
                event.preventDefault();
            }, false);
            document.addEventListener('touchmove', function (event) {
                if (touch_x == 0 || touch_y == 0) return;
                var xUp = event.touches[0].clientX,
					yUp = event.touches[0].clientY,
					xDiff = touch_x - xUp,
					yDiff = touch_y - yUp;
                if (Math.abs(xDiff) > 75 && Math.abs(xDiff) > Math.abs(yDiff)) {
                    if (xDiff > 0) { //left
                        clearTimeout(touch_timer);
                        touch_slide = true;
                        touch_x = 0;
                        touch_y = 0;

                        if (game.shopping) {
                            ShopNext();
                        } else if (game.menu) {
                            if (game.world == 1) NextWorld();
                            //else if (game.world == 2) ThirdWorld();
                        } else if (game.onboarding) {
                            OnBoard_2();
                        }

                    } else { //right
                        clearTimeout(touch_timer);
                        touch_slide = true;
                        touch_x = 0;
                        touch_y = 0;

                        if (game.shopping) {
                            ShopPrev();
                        } else if (game.menu) {
                            if (game.world == 2) World();
                            else if (game.world == 3) NextWorld();
                        } else if (game.onboarding) {
                            OnBoard_1();
                        }
                    }
                }
            }, false);

            document.addEventListener('touchend', function (event) {
                if (touch_slide) {
                    touch_slide = false;
                    return;
                }
                var touch = [];
                touch.length = game.buttons.length;
                for (var z = 0; z <= event.touches.length - 1; z++) {
                    var touch = event.touches[z],
                        x = parseInt(touch.clientX) - game.layer1.offsetLeft,
                        y = parseInt(touch.clientY) - game.layer1.offsetTop;

                    x = x * game.scale;
                    y = y * game.scale;

                    for (var i = 0; i <= game.buttons.length - 1; i++) {
                        var button = game.buttons[i];
                        if (y > button.y &&
            		        y < button.y + button.height &&
            		        x > button.x &&
            		        x < button.x + button.width) {
                            touch[i] = true;
                            break;
                        }
                    }
                }
                for (var i = 0; i <= game.buttons.length - 1; i++) {
                    if (typeof touch[i] === 'undefined' && game.buttons[i].clicked) {
                        game.buttons[i].mouseup();
                    }
                }
                event.preventDefault();
            }, false);

        },
        load: function () {
            player = new Player();
            enemies = new Enemies();
            sprites = new Sprites();
            background = new Background();
            pad = new Pad();
            man = new Man();
            level = new Level();
            rating = new Rating();
            fade = new Fade();
            wind = new Wind();
			countdown = new CountDown();
			reload = new Reload();
			
            CoinPool.push(new Coin());
            PowerUpPool.push(new PowerUp());
            TornadoPool.push(new Tornado());
            MeteorPool.push(new Meteor());
            BombPool.push(new Bomb());
            FlarePool.push(new Flare());
            ButtonPool.push(new Button());

            txtlevel = new Text(game.ctx3, 0, 20, 15, 44, 54);
            txtbestscore = new Text(game.ctx1, 0, 0, 0, 25, 32);
            txtscore = new Text(game.ctx3, 0, 0, 0, 53, 70);
            txtbombcount = new SmallText(game.ctx3, 0, 70, 162, 22, 26);
            txtflarecount = new SmallText(game.ctx3, 0, 70, 216, 22, 26);
            txtcoincount = new Text(game.ctx3, 0, 133, 25, 36, 46);
            txtcoin = new SmallText(game.ctx3, 0, 70, 106, 22, 26);
            txtsmall = new SmallText(game.ctx3, 0, 0, 0, 29, 38);
            txtshop = new Text(game.ctx3, 0, 0, 0, 23, 30);
			txtad = new Text(game.ctx3, 0, 0, 0, 23, 30);

            shop_can1 = CreateOffScreenCanvas(640, 400);
            shop_can2 = CreateOffScreenCanvas(640, 400);
            shop_can3 = CreateOffScreenCanvas(640, 400);
            shop_can4 = CreateOffScreenCanvas(640, 400);
            shop_can5 = CreateOffScreenCanvas(640, 400);
            shop_can6 = CreateOffScreenCanvas(640, 400);
            shop_can7 = CreateOffScreenCanvas(640, 400);
            shop_can8 = CreateOffScreenCanvas(640, 400);

            game.sound = GetLocalStorage('MARS_SOUND', game.sound);
            game.score = GetLocalStorage('MARS_SCORE', game.score);
            game.level = GetLocalStorage('MARS_LEVEL', game.level);
            game.coin = GetLocalStorage('MARS_COIN', game.coin);
            game.bombcap = GetLocalStorage('MARS_BOMBCAP', game.bombcap);
            game.flarecap = GetLocalStorage('MARS_FLARECAP', game.flarecap);
            game.shields = GetLocalStorage('MARS_SHIELDS', game.shields);
            game.fuel = GetLocalStorage('MARS_FUEL', game.fuel);
            game.lander = GetLocalStorage('MARS_LANDER', game.lander);
            game.type = GetLocalStorage('MARS_TYPE', game.type);
            game.review = GetLocalStorage('MARS_REVIEW', game.review);
            game.onboard = GetLocalStorage('MARS_ONBOARD', game.onboard);
            game.comboa = GetLocalStorage('MARS_COMBOA', game.comboa);
            game.combob = GetLocalStorage('MARS_COMBOB', game.combob);
            game.productPrice_noad = GetLocalStorage('MARS_PRICE_ADS', game.productPrice_noad);
            game.productPrice_coin1 = GetLocalStorage('MARS_PRICE_COIN1', game.productPrice_coin1);
            game.productPrice_coin2 = GetLocalStorage('MARS_PRICE_COIN2', game.productPrice_coin2);
            game.productPrice_shields = GetLocalStorage('MARS_PRICE_SHIELDS', game.productPrice_shields);
            game.productPrice_fuel = GetLocalStorage('MARS_PRICE_FUEL', game.productPrice_fuel);
            game.productPrice_lander = GetLocalStorage('MARS_PRICE_LANDER', game.productPrice_lander);
            game.productPrice_comboa = GetLocalStorage('MARS_PRICE_COMBOA', game.productPrice_comboa);
            game.productPrice_combob = GetLocalStorage('MARS_PRICE_COMBOB', game.productPrice_combob);
            game.productPrice_bombcap = GetLocalStorage('MARS_PRICE_BOMBCAP', game.productPrice_bombcap);
            game.productPrice_flarecap = GetLocalStorage('MARS_PRICE_FLARECAP', game.productPrice_flarecap);

            //game.coin = 1500;  ////////////
            //game.score = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
            //              0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0];
            //SetLocalStorage('MARS_SCORE', game.score);

            if (game.type == 1) {
                SetLander();
            } else if (game.type == 2) {
                SetApollo();
            }

            if (game.shields) {
                SetShields();
            }
            if (game.fuel) {
                SetFuel();
                rating = new DoubleRating();
            }

            game.ctx1.clearRect(90, game.height_half - 204, 465, 408);
            game.ctx0.drawImage(GetImg('marslander'), 70, game.height_quarter - 200);
            game.ctx0.drawImage(GetImg('home_splash_ground'), 0, game.height - 305);

            var start = GetNewButton(game.ctx1, 215, game.height_half - 102, 210, 262, GetImg('btn_splash_play'), game.sounds.click);
            start.call = 'LoadingMenu';
            start.draw();
            game.buttons.push(start);

            var splashCanvas = CreateOffScreenCanvas(640, 355),
                splashContext = splashCanvas.getContext('2d');
            splashContext.drawImage(game.layer0, 0, game.height_quarter - 240, 640, 355, 0, 0, 640, 355);
            game.splashImage = splashCanvas.toDataURL();
            game.share = {
                subject: 'Check out this game!',
                message: '#marslander',
                image: game.splashImage,
                url: ''
            };

            Animate();

            //////// debug levels /////////////
            //game.level = 1;
            //Loading();
        }
    };

var Sprite = function (layer, image, width, height, frames, ticks, infinite, end) {
	this.image = image;
	this.width = width;
	this.height = height;
	this.frames = frames;
	this.ticks = ticks;
	this.layer = layer;
	this.infinite = (typeof infinite === 'undefined') ? true : infinite;
	this.end = (typeof end === 'function') ? end : false;
    
	var frameIndex = 0,
	tickCount = 0,
	blnDraw = true;

	this.draw = function (x, y) {
		tickCount += 1;
		if (tickCount > this.ticks) {
			tickCount = 0;
			if (frameIndex < frames - 1) frameIndex += 1;
			else if (this.infinite) frameIndex = 0;
			else blnDraw = false;
		}

		if (blnDraw) {
			this.layer.drawImage(this.image,
			frameIndex * this.width, 0,
			this.width, this.height,
			x, y,
			this.width, this.height);
		} else if (typeof this.end === 'function') {
			this.end();
			this.reset();
		}
	}

	this.reset = function () {
		frameIndex = 0;
		tickCount = 0;
		blnDraw = true;
	}

	this.kill = function () {
		for (var i = 0; i <= game.sprites.length - 1; i++) {
			if (game.sprites[i] == this) {
				game.sprites.splice(i, 1);
			}
		}
	}
}

var createSound = function (buffer, context, src) {
    var sourceNode = null,
        startedAt = 0,
        pausedAt = 0,
        blnloop = false;
    this.playing = false;
    var gainNode = null;

    var play = function () {
        if (!game.sound) return;
        var offset = pausedAt;

        if (src == 'thrust') {
            sourceNode = context.createBufferSource();
            sourceNode.buffer = buffer;

            gainNode = context.createGain();
            sourceNode.connect(gainNode);
            gainNode.connect(context.destination);

            if (blnloop) sourceNode.loop = true;

            sourceNode.start(0, 0.015);

        } else {
            sourceNode = context.createBufferSource();
            sourceNode.connect(context.destination);
            sourceNode.buffer = buffer;

            if (blnloop) sourceNode.loop = true;

            sourceNode.start(0, offset);
        }

        startedAt = context.currentTime - offset;
        pausedAt = 0;
        this.playing = true;
    };

    var pause = function () {
        var elapsed = context.currentTime - startedAt;
        stop();
        pausedAt = elapsed;
        this.playing = false;
    };

    var stop = function () {
        if (gainNode != null) {
            gainNode.gain.setTargetAtTime(0, context.currentTime, 0.015);
        } else if (sourceNode) {
            sourceNode.disconnect();
            sourceNode.stop(0);
            sourceNode = null;
        }
        pausedAt = 0;
        startedAt = 0;
        this.playing = false;
    };

    var reset = function () {
        if (gainNode != null) {
            gainNode.disconnect();
            gainNode = null;
        }
        if (sourceNode) {
            sourceNode.disconnect();
            sourceNode.stop(0);
            sourceNode = null;
        }
        pausedAt = 0;
        startedAt = 0;
        this.playing = false;
    };

    var loop = function () {
        blnloop = true;
        this.play();
    };

    var getPlaying = function () {
        return this.playing;
    };

    var getCurrentTime = function () {
        if (pausedAt) {
            return pausedAt;
        }
        if (startedAt) {
            return context.currentTime - startedAt;
        }
        return 0;
    };

    var getDuration = function () {
        return buffer.duration;
    };

    return {
        getCurrentTime: getCurrentTime,
        getDuration: getDuration,
        getPlaying: getPlaying,
        play: play,
        pause: pause,
        stop: stop,
        loop: loop,
        reset: reset
    };
}
//var sound = createSound(buffer, context);
//sound.pause();
//sound.play();
//sound.stop();

function PlaySound(buffer, time, loop) {
    var source = context.createBufferSource();
    source.buffer = buffer;
    if (loop) source.loop = true;
    source.connect(context.destination);
    source.start(time);
}

var Sound = function (path, volume, instant, end) {
    this.end = (typeof end === 'function') ? end : false;
    this.path = (typeof path === 'undefined') ? '' : path;
    this.instant = (typeof instant === 'undefined') ? false : instant;
    this.snd = new Audio();
    this.lastTime = Date.now();
    this.currentVolume = 0;
    this.volume = (typeof volume === 'undefined') ? 1 : volume;
    this.fading = false;
    this.snd.src = path;
    this.snd.load();
    this.loaded = false;
	this.timer = null;

    var _this = this,
        playing = false,
        targetVolume = 0,
        volumeIncrease = 0.0023;

    this.snd.addEventListener('canplaythrough', function () {
        _this.loaded = true;
        if (_this.instant) _this.play();
        return false;
    });
    this.snd.addEventListener('stalled', function () {
        _this.snd.src = path;
        _this.snd.load();
    });
    this.snd.addEventListener('error', function () {
        _this.snd.src = path;
        _this.snd.load();
    });

    this.snd.addEventListener('ended', function () {
        if (typeof _this.end === 'function') {
            _this.end();
        }
    });
	
	if (this.path.indexOf('sounds/wind') > -1){
		this.snd.addEventListener('timeupdate', function(){
			var buffer = .50;
			if(this.currentTime > this.duration - buffer){
				this.currentTime = 0;
				this.play();
		}}, false);
	}
		
    this.play = function () {
        try {
            if (game.sound && _this.loaded) {
                if (_this.fading) {
                    _this.fadein();
                } else {
                    this.snd.volume = this.volume;
                    this.snd.play();
                    this.lastTime = Date.now();
                    this.currentVolume = this.volume;
                    playing = true;
                }
            }
        } catch (e) { console.log('error:sound'); }
    }

    this.pause = function () {
        this.snd.pause();
    }

    this.loop = function () {
        this.snd.loop = true;
        this.snd.volume = this.volume;
        this.play();
    }

    this.stop = function () {
        if (playing) {
			clearTimeout(this.timer);
            this.timer = setTimeout(function () { _this.fadeout(); }, 10);
            playing = false;
        }
    }

    this.reset = function () {
        clearTimeout(this.timer);
        this.timer = null;
        _this.snd.pause();
        _this.snd.currentTime = 0;
        _this.currentVolume = 0;
        _this.fading = false;
        playing = false;
    }

    this.fadeout = function () {
        var now = Date.now(),
            delta = now - _this.lastTime,
            diff = targetVolume - _this.currentVolume,
            change = ((diff > 0) ? volumeIncrease : -volumeIncrease) * delta,
            newTestVolume = _this.currentVolume + change;

		clearTimeout(this.timer);
        if (newTestVolume <= targetVolume) {
            _this.reset();
            return;
        }

        _this.fading = true;
        _this.lastTime = now;
        _this.snd.volume = newTestVolume;
        _this.currentVolume = newTestVolume;
        this.timer = setTimeout(function () { _this.fadeout(); }, 10);
    }

    this.fadein = function () {
        var now = Date.now(),
            delta = now - _this.lastTime,
            diff = _this.volume - _this.currentVolume,
            change = ((diff > 0) ? volumeIncrease : -volumeIncrease) * delta,
            newTestVolume = _this.currentVolume + change;
		
		clearTimeout(this.timer);
        if (newTestVolume >= _this.volume) {
            _this.fading = false;
            _this.play();
            return;
        }

        _this.lastTime = now;
        _this.snd.volume = newTestVolume;
        _this.currentVolume = newTestVolume;
        this.timer = setTimeout(function () { _this.fadein(); }, 10);
    }

}

var Player = function () {
    var _this = this,
        onetime = true,
        counter = 0;

    this.image = null;
    this.vy = 0;
    this.vx = 0;
    this.thrust = 1.65;
    this.width = 50;
    this.height = 60;
    this.angle = 0;
    this.x = 0;
    this.y = 0;
    this.Y = 450 + game.padding;
    this.l = false;
    this.r = false;
    this.crash = false;
    this.landed = false;
    this.landedsplash = false;
    this.rightThrust = null;
    this.leftThrust = null;
    this.redLight = null;
    this.shields = null;
    this.hit = false;
    this.panx = 0;
    this.pany = 0;
    this.alpha = 1;
    this.over = false;
    this.bigbang = null;
    this.smokeLeft = null;
    this.smokeRight = null;
    this.pos = {
        redlight: {
            x: -20,
            y: 27
        },
        thrust: {
            right: {
                x: 16,
                y: 6
            },
            left: {
                x: -28,
                y: 6
            }
        }
    };
    this.rightThrust = new Sprite(game.ctx1, gameimages.rthrust, 47, 66, 2, 3);
    this.leftThrust = new Sprite(game.ctx1, gameimages.lthrust, 47, 66, 2, 3);
    this.redLight = new Sprite(game.ctx1, gameimages.red_light, 38, 15, 4, 10);
    this.shields = new Sprite(game.ctx1, gameimages.shields, 75, 75, 2, 5);
    this.smokeLeft = new Sprite(game.ctx1, gameimages.smoke, 30, 29, 10, 3, false, function () {
        onetime = false;
    });
    this.smokeRight = new Sprite(game.ctx1, gameimages.smoke, 30, 29, 10, 3, false, function () {
        onetime = false;
    });
    this.bigbang = new Sprite(game.ctx1, gameimages.crash, 120, 120, 8, 2, false, function () {
        _this.over = true;
    });

    this.draw = function () {
        game.ctx1.save();

        if (this.hit) {
            counter += 1;
            if (counter >= 20) {
                this.hit = false;
                counter = 0;
            } else if (counter == 1) {
                game.sounds.hit.play();
            }
            if (counter % 2 == 0) game.ctx1.translate(this.x + 26, this.y + 31);
            else game.ctx1.translate(this.x + 24, this.y + 29);
            game.ctx1.rotate((this.angle * 360) * (Math.PI / 180));
            game.ctx1.drawImage(this.image, 0, 0, 50, 60, -25, -30, 50, 60);
            this.shields.draw(-37, -36);
        } else {
            game.ctx1.translate(this.x + 25, this.y + 30);
            game.ctx1.rotate((this.angle * 360) * (Math.PI / 180));
            game.ctx1.drawImage(this.image, 0, 0, 50, 60, -25, -30, 50, 60);
        }

        if (level.night) {
            game.ctx1.drawImage(this.image, 50, 0, 50, 60, -25, -30, 50, 60);
            if (this.alpha < 1) {
                game.ctx1.globalAlpha = this.alpha;
                game.ctx1.drawImage(this.image, 100, 0, 50, 60, -25, -30, 50, 60);
                game.ctx1.globalAlpha = 1.0;
            }
            game.ctx1.drawImage(gameimages.spot_light, -176, -78);
            this.redLight.draw(this.pos.redlight.x, this.pos.redlight.y);
        }

        if (this.l) {
            this.rightThrust.draw(this.pos.thrust.right.x, this.pos.thrust.right.y);
        }

        if (this.r) {
            this.leftThrust.draw(this.pos.thrust.left.x, this.pos.thrust.left.y);
        }

        if (this.l || this.r) {
            game.sounds.thrust.play();
        } else {
            game.sounds.thrust.stop();
        }

        if (onetime && this.vy != 0 && this.r) {
            this.smokeRight.draw(-36, 8);
        }
        if (onetime && this.vy != 0 && this.l) {
            this.smokeLeft.draw(8, 8);
        }
        game.ctx1.restore();

        this.l = false;
        this.r = false;
    }

    this.explosion = function () {
        this.bigbang.draw(this.x - 35, this.y - 30);
        if (this.over) {
            game.ctx1.drawImage(gameimages.crash,
                840, 0,
                120, 120,
                this.x - 35, this.y - 30,
                120, 120);
        }
    }

    this.reset = function () {
        onetime = true;
        counter = 0;
        this.crash = false;
        this.vy = 0;
        this.vx = 0;
        this.thrust = 1.65;
        this.width = 50;
        this.height = 60;
        this.angle = 0;
        this.x = 0;
        this.y = 0;
        this.l = false;
        this.r = false;
        this.crash = false;
        this.hit = false;
        this.panx = 0;
        this.pany = 0;
        this.over = false;
        this.alpha = 1;

        game.sounds.thrust.volume = 0.75;
        game.sounds.explosion.volume = 0.5;

        if (game.type == 2) {
            this.pos.redlight.x = -19;
            this.pos.redlight.y = -37;
            this.pos.thrust.left.x = -39;
            this.pos.thrust.left.y = -12;
            this.pos.thrust.right.x = -6;
            this.pos.thrust.right.y = -12;

            this.rightThrust.width = 47;
            this.rightThrust.heigth = 66;
            this.rightThrust.image = gameimages.rthrust;
            this.leftThrust.width = 47;
            this.leftThrust.heigth = 66;
            this.leftThrust.image = gameimages.lthrust;
            this.thrust = 1.05;
        } else if (game.type == 1) {
            this.pos.redlight.x = -20;
            this.pos.redlight.y = 27;
            this.pos.thrust.left.x = -28;
            this.pos.thrust.left.y = 6;
            this.pos.thrust.right.x = 16;
            this.pos.thrust.right.y = 6;

            this.rightThrust.width = 13;
            this.rightThrust.heigth = 22;
            this.rightThrust.image = gameimages.rthrust;
            this.leftThrust.width = 13;
            this.leftThrust.heigth = 22;
            this.leftThrust.image = gameimages.lthrust;
            this.thrust = 1.65;
        }
        this.image = gameimages.ship;
    };

    this.clear = function () {
        this.image = null;
        this.bigbang.reset();
        this.smokeLeft.reset();
        this.smokeRight.reset();
    }

    var pi = Math.PI / 180;
    this.right = function (rate) {
        if (rating.rate <= 0) {
            if (!game.message) {
                game.message = true;
                reload.init(110, game.height_quarter - 7, game.ctx3, gameimages.text_nofuel, 1);
                sprites.sprite.push(reload);
            }
            return;
        }
        rating.rate -= game.rates.fuel.single;
        
        if (game.type == 2) {
            var hyp = game.gravity * player.thrust * rate;
            this.vx += hyp;
            this.vy -= 0.1;
            //this.vx += 0.1;
        } else {
            var hyp = game.gravity * player.thrust * rate;
            this.vy -= (hyp * Math.sin((90 - (player.angle * 360)) * (pi)));
            this.vx += (hyp * Math.cos((90 - (player.angle * 360)) * (pi)));

            this.vy += Math.sin(player.angle);
            player.angle += 0.0018;
        }
        this.r = true;
    };
    this.left = function (rate) {
        if (rating.rate <= 0) {
            if (!game.message) {
                game.message = true;
                reload.init(110, game.height_quarter - 7, game.ctx3, gameimages.text_nofuel, 1);
                sprites.sprite.push(reload);
            }
            return;
        }
        rating.rate -= game.rates.fuel.single;

        if (game.type == 2) {
            var hyp = game.gravity * player.thrust * rate;
            this.vx -= hyp;
            this.vy -= 0.1;
            //this.vx -= 0.1;
        } else {
            var hyp = game.gravity * player.thrust * rate;
            this.vy -= (hyp * Math.sin((90 - (player.angle * 360)) * (pi)));
            this.vx += (hyp * Math.cos((90 - (player.angle * 360)) * (pi)));

            this.vy += Math.sin(-player.angle);
            player.angle -= 0.0018;
        }
        this.l = true;
    };
    this.up = function (rate) {
        if (rating.rate <= 0) {
            if (!game.message) {
                game.message = true;
                reload.init(110, game.height_quarter - 7, game.ctx3, gameimages.text_nofuel, 1);
                sprites.sprite.push(reload);
            }
            return;
        }
        rating.rate -= game.rates.fuel.double;
        
        if (game.type == 2) {
            //this.vy -= 0.15;
            this.vy -= game.gravity * 1.65 * rate;
        } else {
            var hyp = game.gravity * player.thrust * rate;
            this.vy -= (hyp * Math.sin((90 - (player.angle * 360)) * (pi)));
            this.vx += (hyp * Math.cos((90 - (player.angle * 360)) * (pi)));
        }
        this.r = true;
        this.l = true;
    }
}

var Wind = function () {
    this.speed = 0;
    this.x = 0;
    this.dir = 1;
    this.night = false;

    this.image = CreateOffScreenCanvas(game.width, game.height);
    var ctx = this.image.getContext('2d');
    DrawTile(ctx, gameimages.debris);
    
    this.draw = function () {
        
        if (!this.night) {
            game.ctx1.drawImage(this.image, this.x, 0);
            game.ctx1.drawImage(this.image, this.x - (640 * this.dir), 0);

            this.x += this.speed;
            if (this.x >= 640) {
                this.x = 0;
            } else if (this.x <= -640) {
                this.x = 0;
            }
        }
    }

    this.init = function (speed, night) {
		this.x = 0;
		this.speed = speed;
		this.night = night;
		
		if (this.speed > 0 && this.speed < 1) this.speed = 1;
        if (this.speed < 0 && this.speed > -1) this.speed = -1;
        this.speed = this.speed * 10;
		
        if (this.speed < 0) {
            this.dir = -1;
        }else{
			this.dir = 1;
		}
    }

}

function Flares () {
    level.flare = true;

    if (level.night) {
        deploy_flare = GetNewButton(game.ctx3, 0, game.height - 375, 200, 125, gameimages.btn_flare, '', 0, 0, gameimages.btn_flare_on);
        deploy_flare.call = 'DeployFlare';
        game.buttons.push(deploy_flare);
    }
}

function DrawFlares () {
    game.ctx3.drawImage(gameimages.score_bg, 0, 0, 58, 50, 10, 205, 58, 50);
    game.ctx3.drawImage(gameimages.score_bg, 30, 0, 10, 50, 68, 205, (game.flares.toString().length * 22) - 10, 50);
    game.ctx3.drawImage(gameimages.score_bg, 120, 0, 30, 50, (game.flares.toString().length * 22) + 58, 205, 30, 50);
    game.ctx3.drawImage(gameimages.flares, 0, 0, 80, 80, 10, 200, 60, 60);
    txtflarecount.text = game.flares;
    txtflarecount.draw();
}

var ActiveFlares = [];
var FlarePool = [];

function GetNewFlare(x, y) {
    var b = null;
    if (FlarePool.length > 0) {
        b = FlarePool.pop();
    } else {
        b = new Flare();
    }

    b.init(x, y, game.ctx1, gameimages.flare);

    ActiveFlares.push(b);
    return b;
}

function FreeFlare(b) {
    for (var i = 0, l = ActiveFlares.length; i < l; i++)
        if (ActiveFlares[i] == b)
            ActiveFlares.splice(i, 1);

    FlarePool.push(b);
}

var Flare = function () {
    this.x = 0;
    this.X = 0;
    this.speed = 1;
    this.y = 0;
    this.Y = 0;
    this.dir = 1;
    this.speed = 1;
    this.height = 80;
    this.width = 98;
    this.halfwidth = 49;
    this.halfheight = 40;
    this.frames = 5;
    this.ticks = 3;
    this.infinite = true;
    this.frameIndex = 0;
    this.tickCount = 0;
    this.flagged = false;
    this.killed = false;
    this.alpha = 1;

    this.draw = function (x, y, windspeed) {

        if (this.alpha > 0) {
            
            this.X = this.x + x + windspeed - 35;
            this.Y = this.y + y + this.speed;

            this.x += windspeed;
            this.y += this.speed;

            this.tickCount += 1;
            if (this.tickCount > this.ticks) {
                this.tickCount = 0;
                if (this.frameIndex < this.frames - 1) this.frameIndex += 1;
                else if (this.infinite) this.frameIndex = 0;
            }

            this.layer.globalAlpha = this.alpha;

            this.layer.drawImage(this.image,
                this.frameIndex * this.width, 0,
                this.width, this.height,
                this.X, this.Y,
                this.width, this.height);
            
            this.layer.globalAlpha = 1.0;

            this.alpha -= 0.0075;
        } else {
            this.alpha = 1;
            this.flagged = true;
        }
    }

    this.init = function (x, y, layer, image) {
        this.x = x;
        this.y = y;
        this.X = 0;
        this.Y = 0;
        this.layer = layer;
        this.image = image
        this.frames = 5;
        this.ticks = 3;
        this.frameIndex = 0;
        this.tickCount = 0;
        this.flagged = false;
        this.killed = false;
        this.alpha = 1;
    }

}

function Bombs () {
    deploy_bomb = GetNewButton(game.ctx3, 440, game.height - 375, 200, 125, gameimages.btn_bomb, '', 0, 0, gameimages.btn_bomb_on);
    deploy_bomb.call = 'DeployBomb';
    game.buttons.push(deploy_bomb);
    level.bomb = true;
}

function DrawBombs() {
    game.ctx3.drawImage(gameimages.score_bg, 0, 0, 58, 50, 10, 150, 58, 50);
    game.ctx3.drawImage(gameimages.score_bg, 30, 0, 10, 50, 68, 150, (game.bombs.toString().length * 22) - 10, 50);
    game.ctx3.drawImage(gameimages.score_bg, 120, 0, 30, 50, (game.bombs.toString().length * 22) + 58, 150, 30, 50);
    game.ctx3.drawImage(gameimages.bombs, 0, 0, 50, 50, 20, 155, 40, 40);
    
    txtbombcount.text = game.bombs;
    txtbombcount.draw();
}

var ActiveBombs = [];
var BombPool = [];

function GetNewBomb(x, y) {
    var b = null;
    if (BombPool.length > 0) {
        b = BombPool.pop();
    } else {
        b = new Bomb();
    }

    b.init(x, y, game.ctx1, gameimages.bomb, gameimages.bombsmoke);

    ActiveBombs.push(b);
    return b;
}

function FreeBomb(b) {
    for (var i = 0, l = ActiveBombs.length; i < l; i++)
        if (ActiveBombs[i] == b)
            ActiveBombs.splice(i, 1);

    BombPool.push(b);
}

var Bomb = function () {
    this.x = 0;
    this.X = 0;
    this.y = 0;
    this.Y = 0;
    this.layer = null;
    this.image = null;
    this.imageup = null;
    this.width = 50;
    this.height = 50;
    this.halfwidth = 25;
    this.halfheight = 25;
    this.flagged = false;
    this.killed = false;
    this.frames = 24;
    this.ticks = 2;
    this.infinite = false;
    this.end = false;
    this.frameIndex = 0;
    this.tickCount = 0;
    this.blnDraw = true;

    this.init = function (x, y, layer, image, up) {
        this.x = x;
        this.y = y;
        this.X = 0;
        this.Y = 0;
        this.end = false;
        this.layer = layer;
        this.image = image;
        this.imageup = up;
        this.flagged = false;
        this.frames = 24;
        this.ticks = 2;
        this.width = 50;
        this.height = 50;
        this.infinite = false;
        this.frameIndex = 0;
        this.tickCount = 0;
        this.blnDraw = true;
        this.killed = false;
    }

    this.draw = function (x, y) {
        this.X = this.x + x;
        this.Y = this.y + y;

        this.tickCount += 1;
        if (this.tickCount > this.ticks) {
            this.tickCount = 0;
            if (this.frameIndex < this.frames - 1) this.frameIndex += 1;
            else if (this.infinite) this.frameIndex = 0;
            else this.blnDraw = false;
        }

        if (this.blnDraw) {
            this.layer.drawImage(this.image,
                this.frameIndex * this.width, 0,
                this.width, this.height,
                this.X, this.Y,
                this.width, this.height);
        } else if (this.killed) {
            this.flagged = true;
        } else {
            this.flagged = true;
        }
    }

    this.kill = function () {
        this.killed = true;
        this.image = this.imageup;
        this.width = 250;
        this.height = 245;
        this.frames = 10;
        this.ticks = 2;
        this.infinite = false;
        this.end = true;
        this.frameIndex = 0;
        this.tickCount = 0;
        this.blnDraw = true;
        this.flagged = false;
        this.x = this.x - 95;
        this.y = this.y - 95;
    }
}

var Enemies = function () {
    this.enemy = [];
    this.draw = function () {
        for (var i = this.enemy.length - 1; i >= 0; i--) {
            if (!this.enemy[i].flagged) {
                this.enemy[i].draw(player.panx, player.pany);
            } else {
                if (enemies.enemy[i] instanceof PowerUp) {
                    FreePowerUp(enemies.enemy[i]);
                    this.enemy.splice(i, 1);
                }else if (enemies.enemy[i] instanceof Coin) {
                    FreeCoin(enemies.enemy[i]);
                    this.enemy.splice(i, 1);
                }else if (enemies.enemy[i] instanceof Meteor) {
                    enemies.enemy[i].reset();
                    GetSwooshSound();
                }
                
            }
        }
    }

    this.reset = function () {
        for (var i = this.enemy.length - 1; i >= 0; i--) {
            if (enemies.enemy[i] instanceof PowerUp) FreePowerUp(enemies.enemy[i]);
            else if (enemies.enemy[i] instanceof Coin) FreeCoin(enemies.enemy[i]);
            else if (enemies.enemy[i] instanceof Tornado) FreeTornado(enemies.enemy[i]);
            else if (enemies.enemy[i] instanceof Meteor) FreeMeteor(enemies.enemy[i]);
        }

        this.enemy = [];
    }
}

var Sprites = function () {
    this.sprite = [];
    this.draw = function () {
        for (var i = this.sprite.length - 1; i >= 0; i--) {
            if (this.sprite[i] instanceof Bomb) {
                if (!this.sprite[i].flagged) {
                    this.sprite[i].draw(player.panx, player.pany);
                }else {
                    if (this.sprite[i].killed) {
                        FreeBomb(this.sprite[i]);
                        this.sprite.splice(i, 1);
                        continue;
                    }
                    level.explosion(this.sprite[i].x, this.sprite[i].y);
                    level.draw();
                    this.sprite[i].kill();
                    GetBombSound();
                }
			}else if (this.sprite[i] instanceof Flare) {
                if (!this.sprite[i].flagged) {
                    this.sprite[i].draw(player.panx, player.pany, level.windSpeed);
                    var alpha = this.sprite[i].alpha;
                    if (alpha > 0) {
                        background.alpha = alpha;
                        player.alpha = alpha;
                        man.alpha = alpha;
                     
                    }
                } else {
                    FreeFlare(this.sprite[i]);
                    this.sprite.splice(i, 1);
                    background.alpha = 1;
                    player.alpha = 1;
                    man.alpha = 1;
                }
            } else if (this.sprite[i] instanceof Reload) {
                if (!this.sprite[i].flagged) {
                    this.sprite[i].draw(0, 0);
                } else {
                    this.sprite.splice(i, 1);
                    game.message = false;
                }
            } 
        }
    }

    this.reset = function () {
        for (var i = this.sprite.length - 1; i >= 0; i--) {
            if (this.sprite[i] instanceof Bomb) FreeBomb(this.sprite[i]);
            else if (this.sprite[i] instanceof Flare) FreeFlare(this.sprite[i]);
            else this.sprite.splice(i, 1);
        }

        this.sprite = [];
    }
}

var ActiveTornados = [];
var TornadoPool = [];

function GetNewTornado(x, y, x2, speed, dir) {
    var b = null;
    if (TornadoPool.length > 0)
        b = TornadoPool.pop();
    else
        b = new Tornado();

    b.init(x, y, x2, speed, dir, game.ctx1, gameimages.tornado);

    ActiveTornados.push(b);
    return b;
}

function FreeTornado(b) {
    for (var i = 0, l = ActiveTornados.length; i < l; i++)
        if (ActiveTornados[i] == b)
            ActiveTornados.splice(i, 1);
    TornadoPool.push(b);
}

var Tornado = function () {
    this.x = 0;
    this.X = 0;
    this.xEnd = 0;
    this.xStart = 0;
    this.y = 0;
    this.Y = 0;
    this.dir = 1;
    this.speed = 1;
    this.height = 173;
    this.width = 50;
    this.halfwidth = 25;
    this.halfheight = 86;
    this.frames = 2;
    this.ticks = 5;
    this.infinite = true;
    this.end = false;
    this.frameIndex = 0;
    this.tickCount = 0;

    this.draw = function (x, y) {
        this.X = this.x + x;
        this.Y = this.y + y;

        if (this.X > this.xEnd + x || this.X < this.xStart + x) {
            this.speed = -1 * this.speed;
        }
        this.x += this.speed;
        

        this.tickCount += 1;
        if (this.tickCount > this.ticks) {
            this.tickCount = 0;
            if (this.frameIndex < this.frames - 1) this.frameIndex += 1;
            else this.frameIndex = 0;
        }

        this.layer.drawImage(this.image,
            this.frameIndex * this.width, 0,
            this.width, this.height,
            this.X, this.Y,
            this.width, this.height);

        this.Y += 50;
    }

    this.init = function (x, y, x2, speed, dir, layer, image) {
        this.x = x;
        this.y = y;
        this.X = 0;
        this.Y = 0;
        this.xEnd = x2;
        this.xStart = x;
        this.layer = layer;
        this.image = image;
        this.speed = speed;
        this.dir = dir;
        this.frames = 2;
        this.ticks = 5;
        this.frameIndex = 0;
        this.tickCount = 0;
        
        if (x > x2) {
            this.xEnd = x;
            this.xStart = x2;
        }

        if (this.dir == 'left') {
            this.speed = -1 * this.speed;
        }
    }

}

var ActiveMeteors = [];
var MeteorPool = [];

function GetNewMeteor(speed, angle, width, height, dir, delay) {
    var b = null;
    if (MeteorPool.length > 0)
        b = MeteorPool.pop();
    else
        b = new Meteor();

    b.init(speed, angle, width, height, dir, game.ctx1, gameimages.meteor);

    ActiveMeteors.push(b);
    return b;
}

function FreeMeteor(b) {
    for (var i = 0, l = ActiveMeteors.length; i < l; i++)
        if (ActiveMeteors[i] == b)
            ActiveMeteors.splice(i, 1);
    MeteorPool.push(b);
}


var Meteor = function () {
    this.x = 0;
    this.X = 0;
    this.y = 0;
    this.Y = 0;
    this.W = 0;
    this.H = 900;
    this.width = 10;
    this.height = 10;
    this.halfwidth = 5;
    this.halfheight = 5;
    this.speed = 0;
    this.angle = 0;
    this.dir = 1;
    this.flagged = false;
    this.radians = 0;
    this.xpos = 0;
    this.ypos = 0;
    this.layer = null;
    this.image = null;
    this.initspeed = 0;
    this.xdir = 0;

    this.draw = function (x, y) {
        this.x += this.xpos;
        this.y += this.ypos;
        this.X = this.x - 9;
        this.Y = this.y + 24;

        if (this.x > 655 || this.x < -15) {
            this.kill();
        }

        this.layer.drawImage(this.image,
            this.xdir, 0,
            45, 30,
            this.X, this.Y,
            45, 30);
    }

    this.kill = function () {
        this.flagged = true;
    }

    this.init = function (speed, angle, width, height, dir, layer, image) {
        this.speed = speed;
        this.angle = 25;
        this.dir = dir;
        this.W = width;
        this.layer = layer;
        this.image = image;
        this.x = 0;
        this.X = 0;
        this.y = 0;
        this.Y = 0;
        this.speed = this.speed;

        if (this.dir == 1) {
            this.xdir = 45;
        } else {
            this.xdir = 0;
        }

        this.radians = this.angle * (Math.PI / 180);
        this.xpos = this.speed * Math.cos(this.radians) * this.dir;
        this.ypos = this.speed * Math.sin(this.radians);

        this.angle = -(90 - angle) * (Math.PI / 180) * this.dir;

        if (Math.round(Math.random()) == 0) {
            this.x = Math.round(Math.random() * this.W);
            this.y = 0;
            this.dir < 0 ? this.x = 640 - this.x : this.x;
        } else {
            this.dir < 0 ? this.x = 640 : this.x = 0;
            this.y = Math.round(Math.random() * this.H);
        }

        this.initspeed = this.speed;
        this.speed = this.initspeed + Math.floor(Math.random() * (3 + 1));
    }

    this.reset = function () {
        this.x = 0;
        this.X = 0;
        this.y = 0;
        this.Y = 0;
        if (Math.round(Math.random()) == 0) {
            this.x = Math.round(Math.random() * this.W);
            this.y = -30;
            this.dir < 0 ? this.x = 640 - this.x : this.x;
        } else {
            this.dir < 0 ? this.x = 640 : this.x = 0;
            this.y = Math.round(Math.random() * this.H);
        }
        this.speed = this.initspeed + Math.floor(Math.random() * (3 + 1));
        this.flagged = false;
    }

}

function MeteorShower (count, speed, angle, width, height, dir) {
    level.meteor = true;
    GetSwooshSound();

    for (var i = 0; i < count; i++) {
        var meteor = GetNewMeteor(speed, angle, width, height, dir, Math.round(Math.random() * 3000));
        enemies.enemy.push(meteor);
    }
}

var Pad = function () {
    this.x = 0;
    this.y = 0;
    this.width = 100;
    this.height = 10;

    this.draw = function () {
        game.ctx1.drawImage(gameimages.light, this.x - 13 + player.panx, this.y - 19 + player.pany);
        game.ctx1.drawImage(gameimages.light, this.x + this.width - 19 + player.panx, this.y - 19 + player.pany);
    }
}

var Man = function () {
    this.x = 0;
    this.y = 0;
    this.width = 25;
    this.height = 35;
    this.alpha = 1;

    this.draw = function () {
        var x = Math.round(this.x - this.width + player.panx),
            y = this.y - this.height + player.pany;
        if (level.night) {
            game.ctx1.drawImage(gameimages.man, 25, 0, 25, 35, x, y, 25, 35);
            if (this.alpha < 1) {
                game.ctx1.globalAlpha = this.alpha;
                game.ctx1.drawImage(gameimages.man, 50, 0, 25, 35, x, y, 25, 35);
                game.ctx1.globalAlpha = 1.0;
            }
        } else game.ctx1.drawImage(gameimages.man, 0, 0, 25, 35, x, y, 25, 35);
    }
}

var Background = function () {
    this.x = 0;
    this.y = 0;
    this.width = 640;
    this.height = 960;
    this.position = 0;
    this.alpha = 1;

    this.draw = function () {
        if (this.position != -1) {
            var bkga = 0,
				bkgb = 0;
            var offset = player.pany / 10,
                Y = this.position + offset;

            bkga = Math.floor((0.5 + player.panx / 20) / 2) % 800;
            game.ctx1.drawImage(levelimages.backgroundb, 0, 0, 800, 400, bkga, Y, 800, 400);
            if (bkga < 0) game.ctx1.drawImage(levelimages.backgroundb, 0, 0, 800, 400, bkga + 800, Y, 800, 400);
            else game.ctx1.drawImage(levelimages.backgroundb, 0, 0, 800, 400, bkga - 800, Y, 800, 400);

            bkgb = Math.floor((0.5 + player.panx / 4) / 2) % 800;
            Y = this.position + 150 + (offset * 1.15);
            game.ctx1.drawImage(levelimages.backgroundc, 0, 0, 800, 960, bkgb, Y, 800, 960);
            if (bkgb < 0) game.ctx1.drawImage(levelimages.backgroundc, 0, 0, 800, 960, bkgb + 800, Y, 800, 960);
            else game.ctx1.drawImage(levelimages.backgroundc, 0, 0, 800, 960, bkgb - 800, Y, 800, 960);

        } else if (this.alpha < 1) {
            game.ctx1.fillStyle = 'rgba(85,75,75,' + (this.alpha + (Math.random() * (0.1 - 0))) + ')';
            game.ctx1.fillRect(0, 0, game.width, game.height);
        }
    }
}

var DoubleRating = function () {
    this.x = 75;
    this.y = 15;
    this.width = 300;
    this.height = 50;
    this.rate = 150;

    var imageCanvas, imageContext;
    imageCanvas = CreateOffScreenCanvas(450, 150),
    imageContext = imageCanvas.getContext('2d');

    this.draw = function () {
        var rate = this.rate * 2;
        game.ctx1.drawImage(
                imageCanvas,
                0, 75,
                450, 75,
                this.x, this.y,
                300, 50);
        game.ctx1.drawImage(
                imageCanvas,
                0, 0,
                Math.round(rate * 1.5 + 0.01), 75,
                this.x, this.y,
                rate, 50);
    }

    this.hit = function (rate) {
        this.rate -= rate;
        if (this.rate <= 0) {
            this.rate = 0;
        }
    }

    this.reset = function () {
        imageContext.clearRect(0, 0, 450, 150);
        imageContext.drawImage(gameimages.stars, 0, 0);
        imageContext.drawImage(gameimages.stars, 225, 0);

        this.rate = 150;
        if (game.level > 9) this.x = 120;
        else this.x = 75;
    }
}

var Rating = function () {
    this.x = 75;
    this.y = 15;
    this.width = 150;
    this.height = 50;
    this.rate = 150;

    this.draw = function () {
        game.ctx1.drawImage(
                gameimages.stars,
                0, 75,
                225, 75,
                this.x, this.y,
                150, 50);
        game.ctx1.drawImage(
                gameimages.stars,
                0, 0,
                Math.round(this.rate * 1.5 + 0.01), 75,
                this.x, this.y,
                this.rate, 50);
    }

    this.hit = function (rate) {
        this.rate -= rate;
        if (this.rate <= 0) {
            this.rate = 0;
        }
    }

    this.reset = function () {
        this.rate = 150;
        if (game.level > 9) this.x = 120;
        else this.x = 75;
    }
}

var ActivePowerUps = [];
var PowerUpPool = [];

function GetNewPowerUp(x, y) {
    var b = null;
    if (PowerUpPool.length > 0)
        b = PowerUpPool.pop();
    else
        b = new PowerUp();

    b.init(x, y, game.ctx1, gameimages.powerup, gameimages.powerup_success);

    ActivePowerUps.push(b);
    return b;
}

function FreePowerUp(b) {
    for (var i = 0, l = ActivePowerUps.length; i < l; i++)
        if (ActivePowerUps[i] == b)
            ActivePowerUps.splice(i, 1);

    PowerUpPool.push(b);
}

var PowerUp = function () {
    this.x = 0;
    this.X = 0;
    this.y = 0;
    this.Y = 0;
    this.layer = null;
    this.image = null;
    this.imageup = null;
    this.width = 42;
    this.height = 42;
    this.halfwidth = 21;
    this.halfheight = 21;
    this.flagged = false;
    this.killed = false;
    this.frames = 6;
    this.ticks = 5;
    this.infinite = true;
    this.end = false;
    this.frameIndex = 0;
    this.tickCount = 0;
    this.blnDraw = true;

    this.init = function (x, y, layer, image, up) {
        this.x = x;
        this.y = y;
        this.X = 0;
        this.Y = 0;
        this.end = false;
        this.layer = layer;
        this.image = image;
        this.imageup = up;
        this.flagged = false;
        this.frames = 6;
        this.ticks = 5;
        this.width = 42;
        this.height = 42;
        this.infinite = true;
        this.frameIndex = 0;
        this.tickCount = 0;
        this.blnDraw = true;
        this.killed = false;
    }

    this.draw = function (x, y) {
        this.X = this.x + x;
        this.Y = this.y + y;

        this.tickCount += 1;
        if (this.tickCount > this.ticks) {
            this.tickCount = 0;
            if (this.frameIndex < this.frames - 1) this.frameIndex += 1;
            else if (this.infinite) this.frameIndex = 0;
            else this.blnDraw = false;
        }

        if (this.blnDraw) {
            this.layer.drawImage(this.image,
                this.frameIndex * this.width, 0,
                this.width, this.height,
                this.X, this.Y,
                this.width, this.height);
        } else if (this.end) {
            this.flagged = true;
        }
    }

    this.kill = function () {
        this.killed = true;
        this.image = this.imageup;
        this.width = 60;
        this.height = 60;
        this.frames = 15;
        this.ticks = 1;
        this.infinite = false;
        this.end = true;
        this.frameIndex = 0;
        this.tickCount = 0;
    }
}

var ActiveCoins = [];
var CoinPool = [];

function GetNewCoin(x, y) {
    var b = null;
    if (CoinPool.length > 0)
        b = CoinPool.pop();
    else
        b = new Coin();

    b.init(x, y, game.ctx1, gameimages.coin, gameimages.coinup);

    ActiveCoins.push(b);
    return b;
}

function FreeCoin(b) {
    for (var i = 0, l = ActiveCoins.length; i < l; i++)
        if (ActiveCoins[i] == b)
            ActiveCoins.splice(i, 1);
    CoinPool.push(b);
}

var Coin = function () {
    this.x = 0;
    this.X = 0;
    this.y = 0;
    this.Y = 0;
    this.layer = null;
    this.image = null;
    this.imageup = null;
    this.width = 42;
    this.height = 42;
    this.halfwidth = 21;
    this.halfheight = 21;
    this.flagged = false;
    this.killed = false;
    this.frames = 6;
    this.ticks = 5;
    this.infinite = true;
    this.end = false;
    this.frameIndex = 0;
    this.tickCount = 0;
    this.blnDraw = true;

    this.init = function (x, y, layer, image, up) {
        this.x = x;
        this.y = y;
        this.Y = 0;
        this.X = 0;
        this.end = false;
        this.layer = layer;
        this.image = image;
        this.imageup = up;
        this.flagged = false;
        this.frames = 6;
        this.ticks = 5;
        this.width = 44;
        this.height = 42;
        this.infinite = true;
        this.frameIndex = 0;
        this.tickCount = 0;
        this.blnDraw = true;
        this.killed = false;
    }
    
    this.draw = function (x, y) {
        this.X = Math.round(this.x + x);
        this.Y = this.y + y;

        this.tickCount += 1;
        if (this.tickCount > this.ticks) {
            this.tickCount = 0;
            if (this.frameIndex < this.frames - 1) this.frameIndex += 1;
            else if (this.infinite) this.frameIndex = 0;
            else this.blnDraw = false;
        }

        if (this.blnDraw) {
            this.layer.drawImage(this.image,
                this.frameIndex * this.width, 0,
                this.width, this.height,
                this.X, this.Y,
                this.width, this.height);
        } else if (this.end) {
            this.flagged = true;
        }
    }

    this.kill = function () {
        this.image = this.imageup;
        this.width = 50;
        this.height = 115;
        this.frames = 16;
        this.ticks = 1;
        this.y -= 60;
        this.infinite = false;
        this.end = true;
        this.frameIndex = 0;
        this.tickCount = 0;
        this.killed = true;
    }
}


var Text = function (layer, text, x, y, width, height, image) {
    this.layer = layer;
    this.x = x;
    this.y = y;
    this.width = width;
    this.height = height;
    this.text = (typeof text === 'undefined') ? '' : text;
    this.image = (typeof image === 'undefined') ? gameimages.text_numbers : image;
    var list = ['0', '1', '2', '3', '4', '5', '6', '7', '8', '9', '.', '$', '¥', '€', '£', '(', ')', ':'];

    this.draw = function () {
        var x_pos = this.x;
        var str = this.text.toString().replace('-', '');

        for (var i = 0; i < str.length; i++) {
            var char = str.charAt(i),
                index = list.indexOf(char);
            if (index != -1) {
                if (index <= 9){
                    var num = Number(char);
                    this.layer.drawImage(
                        this.image,
                        num * 75, 0,
                        75, 100,
                        x_pos, this.y,
                        this.width, this.height);
                    x_pos += this.width;
                }else if (index == 10){
                    this.layer.drawImage(
                        this.image,
                        750, 0,
                        38, 100,
                        x_pos, this.y,
                        this.width / 2, this.height);
                    x_pos += this.width / 2;
                }else if (index == 11){
                    this.layer.drawImage(
                        this.image,
                        788, 0,
                        50, 100,
                        x_pos, this.y,
                        this.width / 2, this.height);
                    x_pos += this.width / 2;
                }else if (index == 12){
                     this.layer.drawImage(
                        this.image,
                        838, 0,
                        75, 100,
                        x_pos, this.y,
                        this.width, this.height);
                    x_pos += this.width;
                }else if (index == 13){
                    this.layer.drawImage(
                        this.image,
                        913, 0,
                        75, 100,
                        x_pos, this.y,
                        this.width, this.height);
                    x_pos += this.width;
                }else if (index == 14){
                    this.layer.drawImage(
                        this.image,
                        988, 0,
                        75, 100,
                        x_pos, this.y,
                        this.width, this.height);
                    x_pos += this.width;
                } else if (index == 15) {
                    this.layer.drawImage(
                        this.image,
                        1063, 0,
                        38, 100,
                        x_pos, this.y,
                        this.width / 2, this.height);
                    x_pos += this.width / 2;
                } else if (index == 16) {
                    this.layer.drawImage(
                        this.image,
                        1101, 0,
                        38, 100,
                        x_pos, this.y,
                        this.width / 2, this.height);
                    x_pos += this.width / 2;
                } else if (index == 17) {
                    this.layer.drawImage(
                        this.image,
                        1139, 0,
                        38, 100,
                        x_pos, this.y,
                        this.width / 2, this.height);
                    x_pos += this.width / 2;
                }
            } 
        }
    };
    this.overalwidth = function () {
        var width = 0,
            str = this.text.toString();

        for (var i = 0; i < str.length; i++) {
            var char = str.charAt(i),
                index = list.indexOf(char);
            if (index != -1) {
                if (index <= 9) {
                    //width += this.width - (char == '1' ? Math.round(8 * ratio) : Math.round(2 * ratio));
					width += this.width;
                } else if (index == 10) {
                    width += this.width / 2;
                } else if (index == 11) {
                    width += this.width / 2;
                } else if (index == 12) {
                    width += this.width;
                } else if (index == 13) {
                    width += this.width;
                } else if (index == 14) {
                    width += this.width;
                } else if (index == 15 || index == 16 || index == 17 || index == 18 || index == 19 || index == 20 || index == 21 || index == 22) {
                    width += this.width / 2;
                }
            }
        }
        return width;
    }
}

var SmallText = function (layer, text, x, y, width, height, image) {
    this.layer = layer;
    this.x = x;
    this.y = y;
    this.width = width;
    this.height = height;
    this.text = text;
    this.image = (typeof image === 'undefined') ? gameimages.text_numbers_small : image;
    var list = ['0', '1', '2', '3', '4', '5', '6', '7', '8', '9'];

    this.draw = function () {
        var x_pos = this.x;
        var str = this.text.toString().replace('-', '');

        for (var i = 0; i < str.length; i++) {
            var char = str.charAt(i),
                index = list.indexOf(char);
            if (index != -1) {
                if (index <= 9) {
                    var num = Number(char);
                    this.layer.drawImage(
                        this.image,
                        num * 31.5, 0,
                        31.5, 42,
                        x_pos, this.y,
                        this.width, this.height);
                    x_pos += this.width;
                } 
            }
        }
    };
    this.overalwidth = function () {
        var width = 0,
            str = this.text.toString();

        for (var i = 0; i < str.length; i++) {
            var char = str.charAt(i),
                index = list.indexOf(char);
            if (index != -1) {
                if (index <= 9) {
                    width += this.width;
                } 
            }
        }
        return width;
    }
}
var dialogimages = {};
var gameimages = {};

var ActiveButtons = [];
var ButtonPool = [];

function GetNewButton(layer, x, y, width, height, image, sound, sx, sy, downimage, swidth, sheight) {
    var b = null;
    if (ButtonPool.length > 0)
        b = ButtonPool.pop();
    else
        b = new Button();

    b.init(layer, x, y, width, height, image, sound, sx, sy, downimage, swidth, sheight);

    ActiveButtons.push(b);
    return b;
}

function FreeButton(b) {
    for (var i = 0, l = ActiveButtons.length; i < l; i++)
        if (ActiveButtons[i] == b)
            ActiveButtons.splice(i, 1);
    ButtonPool.push(b);
}

function FreeGameButton(b) {
    for (var i = 0, l = game.buttons.length; i < l; i++){
        if (game.buttons[i] == b){
            game.buttons.splice(i, 1);
			FreeButton(b);
		}
	}
}

function FreeButtons() {
    for (var i = game.buttons.length - 1; i >= 0; i--) {
        FreeButton(ActiveButtons[i]);
        ActiveButtons.splice(i, 1);
        game.buttons.splice(i, 1);
    }
    game.buttons = [];
    game.buttons.length = 0;
}

var Button = function () {
    this.layer = null;
    this.image = null;
    this.x = 0;
    this.y = 0;
    this.sx = 0;
    this.sy = 0;
    this.swidth = 0;
    this.sheight = 0;
    this.width = 0;
    this.height = 0;
    this.clicked = false;
    this.call = false;
    this.params = [];
    this.snd = null;
    this.downimage = null;
    this.active = false;
    this.down = false;
    
    this.init = function (layer, x, y, width, height, image, sound, sx, sy, downimage, swidth, sheight) {
        this.layer = layer;
        this.image = image;
        this.x = x;
        this.y = y;
        this.sx = sx == undefined ? 0 : sx;
        this.sy = sy == undefined ? 0 : sy;
        this.swidth = swidth == undefined ? width : swidth;
        this.sheight = sheight == undefined ? height : sheight;
        this.width = width;
        this.height = height;
        this.clicked = false;
        this.call = false;
        this.params = [];
        this.snd = sound == '' ? null : sound;
        this.downimage = downimage == undefined ? null : downimage;
        this.active = false;
        this.down = false;
    }

    this.draw = function () {
        this.active = true;
        this.layer.drawImage(
            this.image,
            this.sx, this.sy,
            this.swidth, this.sheight,
            this.x, this.y,
            this.width, this.height);
    };

    this.mousedown = function () {
        this.down = true;
        if (!this.active) return;
        this.clicked = true;
        if (this.downimage != null && this.active) {
            this.layer.clearRect(this.x, this.y, this.width, this.height);
            this.layer.drawImage(
                this.downimage,
                this.sx, this.sy,
                this.swidth, this.sheight,
                this.x + 3, this.y + 3,
                this.width, this.height);
        }
        if (this.snd != null) this.snd.play();
    };
    this.mouseup = function () {
        if (!this.active) return;
        if (this.downimage != null && this.active) {
            this.layer.clearRect(this.x + 3, this.y + 3, this.width, this.height);
            this.layer.drawImage(
                this.image,
                this.sx, this.sy,
                this.swidth, this.sheight,
                this.x, this.y,
                this.width, this.height);
        }
        this.down = true;
        this.clicked = false;
        this.action();
    };

    this.action = function () {
        //if (this.snd != null) this.snd.play();
        var fn = window[this.call];
        if (typeof fn === 'function') fn.apply(null, this.params);
    }

    this.remove = function () {
        for (var i = 0; i <= game.buttons.length - 1; i++) {
            if (game.buttons[i] == this) {
                game.buttons.splice(i, 1);
            }
        }
    };
}

var Level = function () {
    this.wind = false;
    this.night = false;
    this.flare = false;
    this.bomb = false;
    this.meteor = false;
    this.windSpeed = 0.0;
    this.x = 0;
    this.y = 0;
    this.cheight = 0;
    this.cy = 0;
    this.image = null;
    this.scrollspeed = 1;
    this.height = 0;
    this.ground = 0;
    this.H = 0;
    this.W = 0;
    this.ary = [];
    this.data = [];
    this.cave = false;

    this.data.length = 5;

    this.canvasLevel = CreateOffScreenCanvas(100, 100);
    this.ctxLevel = this.canvasLevel.getContext('2d');;

    var aryCrator = [],
        canvas = CreateOffScreenCanvas(150, 150),
        ctx = canvas.getContext('2d'),
        eindex = 5;

    this.init = function () {
        if (aryCrator.length == 0) {
            ctx.drawImage(gameimages.crator, 0, 0, 300, 300, 0, 0, 150, 150);
            aryCrator = new Uint32Array(ctx.getImageData(0, 0, 150, 150).data.buffer);
        }
        eindex = 5;

        this.windSpeed = 0.0;
        this.wind = false;
        this.night = false;
        this.flare = false;
        this.bomb = false;
        this.meteor = false;
        this.scrollspeed = 1;
        this.ary = [];
        this.cave = false;

        var obj = GetObject(game.level);

        this.image = levelimages.level;
        this.x = obj.backgroundx;
        this.y = obj.backgroundy + game.padding;
        this.height = obj.backgroundheight - 5;
        this.ground = this.y + obj.backgroundheight - player.Y - 65;

        var bgposition = obj.backgroundposition + (obj.backgroundposition != -1 ? game.padding : 0);
        background.position = bgposition;
        background.alpha = 1;
        player.x = 295;
        player.y = player.Y;
        pad.x = obj.padx;
        pad.y = obj.pady + game.padding;
        pad.width = obj.padwidth;
        man.x = obj.manx;
        man.y = obj.many + game.padding;
        man.alpha = 1;

        this.night = obj.night;

        if (obj.cave) {
            this.cave = true;
        }

        if (obj.wind) {
            wind.init(obj.wind, obj.night);
            this.wind = true;
            this.windSpeed = obj.wind;
            game.sounds.wind.snd.loop = true;
        }

        Bombs();
        if (obj.night) Flares();

        if (obj.powerup) {
            for (var key in obj.powerup) {
                var objPowerup = obj.powerup[key];
                var powerup = GetNewPowerUp(objPowerup.x, objPowerup.y + game.padding);
                enemies.enemy.push(powerup);
            }
        }
        if (obj.coin) {
            for (var key in obj.coin) {
                var objCoin = obj.coin[key];
                var coin = GetNewCoin(objCoin.x, objCoin.y + game.padding);
                enemies.enemy.push(coin);
            }
        }
        if (obj.meteor) {
            MeteorShower(obj.meteor.count, obj.meteor.speed, obj.meteor.angle, obj.meteor.width, obj.meteor.height, obj.meteor.dir);
        }
        if (obj.tornado) {
            for (var key in obj.tornado) {
                var objTwister = obj.tornado[key];
                var tornado = GetNewTornado(objTwister.x, objTwister.y + game.padding + 27, objTwister.x2, objTwister.speed, objTwister.dir);
                enemies.enemy.push(tornado);
            }
        }

        this.canvasLevel.width = this.image.width;
        this.canvasLevel.height = this.image.height;
        this.ctxLevel.clearRect(0, 0, this.canvasLevel.width, this.canvasLevel.height);

        this.ctxLevel.drawImage(gameimages.light, pad.x - this.x - 13, pad.y - 19 - this.y);
        this.ctxLevel.drawImage(gameimages.light, pad.x + pad.width - 19 - this.x, pad.y - 19 - this.y);

        //ctxLevel.drawImage(game.images.man, 0, 0, 25, 35, man.x - man.width - this.x, man.y - man.height - this.y, 25, 35);

        this.ctxLevel.drawImage(this.image, 0, 0);

        this.H = Math.round(this.image.height / 2);
        this.W = Math.round(this.image.width / 2);

        canvas.width = this.W;
        canvas.height = this.H;

        ctx.clearRect(0, 0, canvas.width, canvas.height);
        ctx.drawImage(this.image, 0, 0, this.image.width, this.image.height, 0, 0, this.W, this.H);
        this.ary = new Uint32Array(ctx.getImageData(0, 0, this.W, this.H).data.buffer);

        this.cheight = 960 - this.y + 35;
        this.cy = this.y - 35;

        fade.reset();
    }

    this.analyze = function () {
        var xt = 0,
            yt = 0,
            w = 150,
            h = 150,
            W = this.W,
            H = this.H,
            i = 0, j = 0,
            obj = this.data[eindex];

        xt = obj.xt;
        yt = obj.yt;
        i = obj.i;

        for (var r = yt; r < 30 + yt; r += 1) {
            for (var c = xt; c < w + xt; c += 1) {
                var P = ((r * W) + c);
                if (aryCrator[(i * w) + j] != 0 && this.ary[P] != undefined) {
                    this.ary[P] = 0;
                }
                j += 1;
            }
            i += 1;
            j = 0;
        }
        eindex++;
    }


    this.draw = function () {
        man.draw();  //part of canvaslevel?

        var y = this.y + player.pany;
        game.ctx1.drawImage(this.canvasLevel, this.x + player.panx, y);

        var bkga = (player.panx % 795) << 0;
        var Y = y + this.height;
        game.ctx1.drawImage(levelimages.ground, bkga, Y);
        if (bkga < 0) game.ctx1.drawImage(levelimages.ground, bkga + 795, Y);
        else game.ctx1.drawImage(levelimages.ground, bkga - 795, Y);

        if (this.cave) {
            Y = y - 745;
            game.ctx1.drawImage(levelimages.ground, bkga, Y);
            if (bkga < 0) game.ctx1.drawImage(levelimages.ground, bkga + 795, Y);
            else game.ctx1.drawImage(levelimages.ground, bkga - 795, Y);
        }

        //if (eindex < 5) this.analyze();
    }

    this.explosion = function (x, y) {

        var xt = Math.round((x - this.x - 125) / 2),
            yt = Math.round((y - this.y - 125) / 2),
            w = 150,
            h = 150,
            W = this.W,
            H = this.H,
            i = 0, j = 0,
            x1 = x - 75,
            x2 = x + 125,
            y1 = y - 75,
            y2 = y + 125,
            _this = this;

        this.ctxLevel.globalCompositeOperation = 'destination-out';
        this.ctxLevel.drawImage(gameimages.crator, Math.round(x - this.x - 125), Math.round(y - this.y - 125));

        var count = 0;
        eindex = 0;

        var obj = { i: 0, xt: xt, yt: yt };
        this.data[0] = obj;
        obj = { i: 30, xt: xt, yt: yt + 30 };
        this.data[1] = obj;
        obj = { i: 60, xt: xt, yt: yt + 60 };
        this.data[2] = obj;
        obj = { i: 90, xt: xt, yt: yt + 90 };
        this.data[3] = obj;
        obj = { i: 120, xt: xt, yt: yt + 120 };
        this.data[4] = obj;

        //this.analyze();

        var worker = new Worker('worker.js?v6');
        var _this = this;
        worker.addEventListener('message', function (event) {

            _this.ary = event.data['ary'];

        }, false);
        worker.postMessage({
            'data': this.data,
            'ary': this.ary,
            'crator': aryCrator,
            'W': this.W
        });

        if ((player.x - player.panx >= x1 && player.x - player.panx <= x2 ||
            player.x + player.width - player.panx >= x1 && player.x + player.width - player.panx <= x2) &&
            (player.y - player.pany >= y1 && player.y - player.pany <= y2 ||
                player.y + player.height - player.pany >= y1 && player.y + player.height - player.pany <= y2)) {
            player.hit = true;
            rating.hit(game.rates.hit.bomb);
            player.vy += 1;
        }

        if ((pad.x >= x1 - 40 && pad.x <= x2 + 40 ||
            pad.x + pad.width >= x1 - 40 && pad.x + pad.width <= x2 + 40) &&
            (pad.y >= y1 - 40 && pad.y <= y2 + 40 ||
                pad.y + pad.height >= y1 - 40 && pad.y + pad.height <= y2 + 40)) {
            pad.y = 10000;
        }

        if ((man.x - man.width >= x1 - 40 && man.x - man.width <= x2 + 40 ||
            man.x >= x1 - 40 && man.x <= x2 + 40) &&
            (man.y - man.height >= y1 - 40 && man.y - man.height <= y2 + 40 ||
                man.y >= y1 - 40 && man.y <= y2 + 40)) {
            //ctxLevel.clearRect(man.x - man.width - this.x, man.y - man.height - this.y, 25, 35);
            man.y = 10000;
        }

    }

}

var CountDown = function () {
    this.x = 0;
    this.y = 0;
    this.layer = null;
    this.image = null;
    this.width = 100;
    this.height = 120;
    this.halfwidth = 50;
    this.halfheight = 50;
    this.flagged = false;
    this.frames = 3;
    this.ticks = 42;
    this.end = true;
    this.frameIndex = 0;
    this.tickCount = 0;
    this.blnDraw = true;

    this.init = function (x, y, layer, image) {
        this.x = x;
        this.y = y;
        this.X = 0;
        this.Y = 0;
        this.end = true;
        this.layer = layer;
        this.image = image;
        this.flagged = false;
        this.frames = 3;
        this.ticks = 42;
        this.width = 100;
		this.height = 120;
        this.frameIndex = 0;
        this.tickCount = 0;
        this.blnDraw = true;
    }

    this.draw = function (x, y) {

        this.tickCount += 1;
        if (this.tickCount > this.ticks) {
            this.tickCount = 0;
            if (this.frameIndex < this.frames - 1) this.frameIndex += 1;
            else this.blnDraw = false;
        }

		this.layer.clearRect(this.x, this.y, 420, 135);
		
        if (this.blnDraw) {
            this.layer.drawImage(this.image,
                this.frameIndex * this.width, 0,
                this.width, this.height,
                this.x, this.y,
                this.width, this.height);
        } else if (this.end) {
            this.flagged = true;
        }
    }

}

var Reload = function () {
    this.x = 0;
    this.y = 0;
    this.layer = null;
    this.image = null;
    this.width = 420;
    this.height = 135;
    this.flagged = false;
    this.frames = 4;
    this.ticks = 3;
    this.end = true;
    this.frameIndex = 0;
    this.tickCount = 0;
    this.blnDraw = true;

    this.init = function (x, y, layer, image, type) {
        this.x = x;
        this.y = y;
        this.X = 0;
        this.Y = 0;
        this.end = true;
        this.layer = layer;
        this.image = image;
        this.flagged = false;
		this.killed = false;
        this.frames = 1;
        this.ticks = 40;
        this.width = 420;
        if (type == 0) {
            this.height = 135;
        } else {
            this.height = 80;
        }
        this.frameIndex = 0;
        this.tickCount = 0;
        this.blnDraw = true;
    }

    this.draw = function (x, y) {

        this.tickCount += 1;
        if (this.tickCount > this.ticks) {
            this.tickCount = 0;
            if (this.frameIndex < this.frames - 1) this.frameIndex += 1;
            else this.blnDraw = false;
        }

		this.layer.clearRect(this.x, this.y, 420, 135);
		
        if (this.blnDraw) {
            this.layer.drawImage(this.image,
                this.frameIndex * this.width, 0,
                this.width, this.height,
                this.x, this.y,
                this.width, this.height);
		} else if (this.killed){
			this.flagged = true;
        } else if (this.end) {
			this.layer.drawImage(this.image,
                this.frameIndex * this.width, 0,
                this.width, this.height,
                this.x, this.y,
                this.width, this.height);
            this.kill();
        }
    }

	this.kill = function () {
        this.killed = true;
        this.width = 420;
        this.height = 135;
        this.frames = 4;
        this.ticks = 3;
        this.infinite = false;
        this.end = true;
        this.frameIndex = 0;
        this.tickCount = 0;
        this.blnDraw = true;
        this.flagged = false;
    }
}

var Fade = function () {
    this.rate = 0.015;
    this.alpha = 1;

    this.draw = function () {
        if (this.alpha > 0) {
            game.ctx1.fillStyle = 'rgba(0,0,0,' + (this.alpha) + ')';
            game.ctx1.fillRect(0, 0, game.width, game.height);
            this.alpha -= this.rate;
        }
    }
    this.reset = function () {
        this.alpha = 1;
    }

}

